Bug 304 - ftp's mget doesn't work if runique is enabled
ftp's mget doesn't work if runique is enabled
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: ftp (Show other bugs)
5.2
All Linux
low Severity low
: ---
: ---
Assigned To: Cristian Gafton
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 1998-12-04 16:13 EST by Red Hat Bugzilla
Modified: 2008-05-01 11:37 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 1998-12-15 18:17:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Red Hat Bugzilla 1998-12-04 16:13:18 EST
The ftp client has a bug. `mget'' doesn't get any files if
``runique'' is enabled. The problem is inconsistent naming
of temporary files which contain the list of remote files to
get.

Example. Try this .netrc file on a directory that contains
files:

  default login anonymous password user@host
  macdef init
  prompt
  runique
  cd /pub/files
  mget *
  quit

Standard output will be something like this:

  ...
  230 Guest login ok, access restrictions apply.
  prompt
  Interactive mode off.
  runique
  Receive unique on.
  cd /pub/files
  250 CWD command successful.
  mget *
  quit
  221 Goodbye.

Note that ``mget *'' doesn't retrieve any files at all.

More low-level description of the bug. A tmp file name is
created in source file cmds.c, function remglob(), variable
`temp''. In function recvrequest() a unique file name is
created in variable `local'' from the argument char pointer
in `temp''. In other words, gunique() in file ftp.c is
called and appends a .1 (,.2, and so on) to a path. The
output from FTP protocol command NLST is stored in file
/tmp/ftpa*.1. But remglob() tries to load the file contents
from the shorter name (/tmp/ftpa) that has not postfix. So
the mget() function doesn't reach its download loop and
exits without getting any file.

Whoever is more familiar with the code should have no
problems fixing this.
Comment 1 Red Hat Bugzilla 1998-12-15 18:17:59 EST
This is fixed in the devel tree; it will appear in the next rawhide
release.

Note You need to log in before you can comment on or make changes to this bug.